_: {
  services = {
    tlp = {
      enable = true;

      settings = let
        start_charge = 40;
        stop_charge = 60;
      in {
        CPU_SCALING_GOVERNOR_ON_AC = "performance";
        CPU_SCALING_GOVERNOR_ON_BAT = "powersave";

        CPU_ENERGY_PERF_POLICY_ON_AC = "performance";
        CPU_ENERGY_PERF_POLICY_ON_BAT = "power";

        CPU_MIN_PERF_ON_AC = 0;
        CPU_MAX_PERF_ON_AC = 100;
        CPU_MIN_PERF_ON_BAT = 0;
        CPU_MAX_PERF_ON_BAT = 20;

        START_CHARGE_THRESH_BAT0 = start_charge;
        STOP_CHARGE_THRESH_BAT0 = stop_charge;

        START_CHARGE_THRESH_BAT1 = start_charge;
        STOP_CHARGE_THRESH_BAT1 = stop_charge;
      };
    };
  };
}
